# How GitLab Tokens Work

This lesson provides a comprehensive overview of the different types of tokens available in GitLab and their respective uses. Understanding and properly managing these tokens is crucial for securing your GitLab projects and automating CI/CD pipelines efficiently.

[TOC]

## Introduction

GitLab tokens are secure keys that allow you to access GitLab's API, repositories, and automate CI/CD workflows. They are essential for integrating GitLab with external tools and services.

## Deploy Tokens

Deploy tokens allow read-only or read-write (if enabled) access to your repository or registry without requiring a personal user account.

>**__NOTE__**: Deploy tokens CANNOT access the GitLab Public REST API.

### Use Cases:
- Automating the fetching of dependencies from a private project during a build.
- Pulling Docker images from a private container registry within GitLab.

### Creating Deploy Tokens:
You can create deploy tokens at the project or group level:
- **Project Level**: Go to your project's **Settings** > **Repository** > **Deploy Tokens**.
- **Group Level**: Go to your group's **Settings** > **Repository** > **Deploy Tokens**.

### Managing Deploy Tokens:
- List, revoke, or create new tokens through the GitLab UI.
- Note that deploy tokens created at the group level can access all projects within the group.

## Personal Access Tokens (PATs)

Personal Access Tokens (PATs) are used to authenticate with the GitLab API, Git over HTTP, and other authentication-required operations.

### Use Cases:
- Automating scripts that require GitLab API access.
- CI/CD pipelines that interact with other GitLab projects.

### Creating PATs:
1. Go to **User Settings** > **Access Tokens**.
2. Choose a name, expiry date, and the required scopes.
3. Click on **Create Personal Access Token**.

### Managing PATs:
- You can view, revoke, or create new PATs from the **Access Tokens** section in your user settings.

## Project Access Tokens

Project Access Tokens are similar to PATs but are tied to a project instead of a user.

### Use Cases:
- Automating CI/CD pipelines that need to authenticate with the GitLab API.
- Integrations that require project-level access.

### Creating Project Access Tokens:
1. Go to your project's **Settings** > **Access Tokens**.
2. Specify the token name, expiry, and scopes.
3. Click **Create Project Access Token**.

### Managing Project Access Tokens:
- Accessible from the project's **Settings** > **Access Tokens**.

## Group Access Tokens

Group Access Tokens provide API access at the group level, allowing automation across multiple projects within the group.

### Use Cases:
- Managing group-level integrations.
- Automating workflows that span multiple projects in the group.

### Creating Group Access Tokens:
1. Navigate to your group's **Settings** > **Access Tokens**.
2. Enter the necessary information and click **Create Group Access Token**.

### Managing Group Access Tokens:
- Tokens can be managed from the group's **Access Tokens** settings page.

## CI/CD Job Tokens

CI/CD Job Tokens are automatically generated by GitLab for use in CI/CD jobs. They allow temporary access to the GitLab API and are tied to the job's lifecycle.

### Use Cases:
- Cloning submodules or other repositories within the same project.
- Using the GitLab API within a CI/CD job.

### Using CI/CD Job Tokens:
- Available as the `CI_JOB_TOKEN` environment variable in CI/CD jobs.
- No manual creation is needed.

## Best Practices

- **Limit Scope**: Only grant the minimum required permissions to each token.
- **Expiration Dates**: Set expiration dates on tokens to minimize risk.
- **Audit Regularly**: Regularly review and revoke unnecessary tokens.

## Conclusion

Understanding the various types of GitLab tokens and their appropriate use is essential for secure and efficient automation of your CI/CD pipelines and integrations. Always follow best practices for token management to maintain the security of your projects.

[Overview](../../README.md) | [Back](./03_introduction_to_gitlab.md) | [Next](../02_basic_pipelines/01_your_first_pipeline.md)
